# default disable broadway(html5) gdk backend
%bcond_without broadway
# if we dose not support desktop environment, we can disable wayland and colord
%bcond_without wayland
%bcond_without colord
%bcond_without tracker3
%global bin_version 3.0.0
# Filter provides for private modules
%global   __provides_exclude_from ^%{_libdir}/gtk-3.0

Summary:  A multi-platform toolkit for creating graphical user interfaces
Name:     gtk3
Version:  3.24.38
Release:  6%{?dist}
License:  LGPLv2+
URL:      https://www.gtk.org/
Source0:  https://download.gnome.org/sources/gtk+/3.24/gtk+-%{version}.tar.xz

Patch0001: 0001-CVE-2024-6655.patch

BuildRequires: meson, cmake
# X11 backend support
BuildRequires: pkgconfig(xi), pkgconfig(xrandr), pkgconfig(xrender), pkgconfig(xrender), pkgconfig(xcursor), pkgconfig(xfixes), pkgconfig(xinerama), pkgconfig(xcomposite), pkgconfig(xdamage), pkgconfig(xkbcommon), pkgconfig(egl)
BuildRequires: cups-devel, pkgconfig(cloudproviders), pkgconfig(epoxy)
# we need gtk-doc for manpage
BuildRequires: desktop-file-utils, gettext, gtk-doc
BuildRequires: pkgconfig(atk), pkgconfig(atk-bridge-2.0), pkgconfig(avahi-gobject), pkgconfig(cairo), pkgconfig(cairo-gobject), pkgconfig(gdk-pixbuf-2.0), pkgconfig(glib-2.0), pkgconfig(gobject-introspection-1.0), pkgconfig(pango)
%if %{with colord}
BuildRequires: pkgconfig(colord)
%endif
%if %{with tracker3}
BuildRequires: pkgconfig(tracker-sparql-3.0)
%endif
%if %{with wayland}
BuildRequires: pkgconfig(wayland-client)
BuildRequires: pkgconfig(wayland-cursor)
BuildRequires: pkgconfig(wayland-egl)
BuildRequires: pkgconfig(wayland-protocols)
%endif

Requires: atk, cairo, cairo-gobject, glib2, libepoxy, pango, gdk-pixbuf2-modules, libXrandr, gdk-pixbuf2-modules, gtk-update-icon-cache, hicolor-icon-theme, adwaita-icon-theme
%if %{with wayland}
Requires: libwayland-client, libwayland-cursor
%endif

%description
GTK is the primary library used to construct user interfaces. It provides user
interface controls and signal callbacks to respond to user actions.

This package contains version 3 of GTK+.

%package -n gtk-update-icon-cache
Summary: Icon theme caching utility

%description -n gtk-update-icon-cache
GTK is the primary library used to construct user interfaces. It provides user
interface controls and signal callbacks to respond to user actions.

%package immodules
Summary: Input methods for GTK+
Requires: gtk3 = %{version}-%{release}

%description immodules
GTK is the primary library used to construct user interfaces. It provides user
interface controls and signal callbacks to respond to user actions.

%package immodule-xim
Summary: XIM support for GTK+
Requires: gtk3 = %{version}-%{release}

%description immodule-xim
GTK is the primary library used to construct user interfaces. It provides user
interface controls and signal callbacks to respond to user actions.

This package contains XIM support for GTK+ 3.

%package devel
Summary: Development files for GTK+
Requires: gtk3 = %{version}-%{release}

%description devel
GTK is the primary library used to construct user interfaces. It provides user
interface controls and signal callbacks to respond to user actions.

This package contains the libraries and header files.

%package tests
Summary: Tests for the %{name} package
Requires: %{name} = %{version}-%{release}

%description tests
The %{name}-tests package contains tests that can be used to verify
the functionality of the installed %{name} package.



%prep
%autosetup -p1 -n gtk+-%{version}



%build
export CFLAGS='-fno-strict-aliasing %optflags'
%meson \
        -Dbuiltin_immodules=auto \
        -Dcloudproviders=true \
        -Dgtk_doc=false \
        -Dinstalled_tests=true \
        -Dman=true \
        -Dxinerama=yes \
%if %{with broadway}
        -Dbroadway_backend=true \
%else
        -Dbroadway_backend=false \
%endif
%if %{with tracker3}
        -Dtracker3=true \
%else
        -Dtracker3=false \
%endif
%if %{with colord}
        -Dcolord=yes \
%else
        -Dcolord=no \
%endif
%if %{with wayland}
        -Dwayland_backend=true
%else
        -Dwayland_backend=false
%endif
%meson_build



%install
%meson_install

%find_lang gtk30
%find_lang gtk30-properties

touch %{buildroot}%{_libdir}/gtk-3.0/%{bin_version}/immodules.cache

mkdir -p %{buildroot}%{_sysconfdir}/gtk-3.0
mkdir -p %{buildroot}%{_libdir}/gtk-3.0/modules
mkdir -p %{buildroot}%{_libdir}/gtk-3.0/immodules



%check
%transfiletriggerin -- %{_libdir}/gtk-3.0/3.0.0/immodules
gtk-query-immodules-3.0 --update-cache &>/dev/null || :

%transfiletriggerpostun -- %{_libdir}/gtk-3.0/3.0.0/immodules
gtk-query-immodules-3.0 --update-cache &>/dev/null || :



%files -f gtk30.lang
%license COPYING
%doc NEWS
%{_bindir}/gtk-query-immodules-3.0*
%{_bindir}/gtk-launch
%{_libdir}/libgtk-3.so.*
%{_libdir}/libgdk-3.so.*
%{_libdir}/libgailutil-3.so.*
%{_libdir}/girepository-1.0
%dir %{_libdir}/gtk-3.0
%dir %{_libdir}/gtk-3.0/%{bin_version}
%dir %{_libdir}/gtk-3.0/%{bin_version}/immodules
%{_libdir}/gtk-3.0/%{bin_version}/printbackends
%{_libdir}/gtk-3.0/modules
%{_libdir}/gtk-3.0/immodules
%ghost %{_libdir}/gtk-3.0/%{bin_version}/immodules.cache
%{_mandir}/man1/gtk-query-immodules-3.0*
%{_mandir}/man1/gtk-launch.1*
%if %{with broadway}
%{_bindir}/broadwayd
%{_mandir}/man1/broadwayd.1*
%endif
%{_datadir}/gtk-3.0/emoji/
%{_datadir}/themes/Default
%{_datadir}/themes/Emacs
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.ColorChooser.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.Debug.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.EmojiChooser.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.Settings.FileChooser.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gtk.exampleapp.gschema.xml
%dir %{_datadir}/gtk-3.0

%files -n gtk-update-icon-cache
%license COPYING
%{_bindir}/gtk-update-icon-cache
%{_mandir}/man1/gtk-update-icon-cache.1*

%files immodules
%{_libdir}/gtk-3.0/%{bin_version}/immodules/
%config(noreplace) %{_sysconfdir}/gtk-3.0/im-multipress.conf

%files immodule-xim
%{_libdir}/gtk-3.0/%{bin_version}/immodules/im-xim.so

%files devel -f gtk30-properties.lang
%{_libdir}/lib*.so
%{_includedir}/*
%{_datadir}/aclocal/*
%{_libdir}/pkgconfig/*
%{_bindir}/gtk3-demo
%{_bindir}/gtk3-icon-browser
%{_bindir}/gtk-builder-tool
%{_bindir}/gtk-encode-symbolic-svg
%{_bindir}/gtk-query-settings
%{_bindir}/gtk3-demo-application
%{_bindir}/gtk3-widget-factory
%{_datadir}/applications/gtk3-demo.desktop
%{_datadir}/applications/gtk3-icon-browser.desktop
%{_datadir}/applications/gtk3-widget-factory.desktop
%{_datadir}/icons/hicolor/*/apps/gtk3-demo.png
%{_datadir}/icons/hicolor/*/apps/gtk3-demo-symbolic.symbolic.png
%{_datadir}/icons/hicolor/*/apps/gtk3-widget-factory.png
%{_datadir}/icons/hicolor/*/apps/gtk3-widget-factory-symbolic.symbolic.png
%{_datadir}/gettext/
%{_datadir}/gir-1.0
%{_datadir}/glib-2.0/schemas/org.gtk.Demo.gschema.xml
%{_datadir}/gtk-3.0/gtkbuilder.rng
%{_datadir}/gtk-3.0/valgrind/
%{_mandir}/man1/gtk3-demo.1*
%{_mandir}/man1/gtk3-demo-application.1*
%{_mandir}/man1/gtk3-icon-browser.1*
%{_mandir}/man1/gtk3-widget-factory.1*
%{_mandir}/man1/gtk-builder-tool.1*
%{_mandir}/man1/gtk-encode-symbolic-svg.1*
%{_mandir}/man1/gtk-query-settings.1*

%files tests
%{_libexecdir}/installed-tests/
%{_datadir}/installed-tests/



%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.24.38-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Mon Sep 23 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.24.38-5
- [Type] Security
- [DESC] fix CVE-2024-6655

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.24.38-4
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.24.38-3
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 23 2023 Miaojun Dong <zoedong@tencent.com> - 3.24.38-2
- Rebuild for at-spi2-core-2.49.90

* Mon Jul 31 2023 Shuo Wang <abushwang@tencent.com> - 3.24.38-1
- update to 3.24.38

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.24.34-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.24.34-3
- Rebuilt for OpenCloudOS Stream 23

* Mon Nov 21 2022 Zhao Zhen <jeremiazhao@tencent.com> - 3.24.34-2
- recoverd some subpackages.

* Wed Jun 01 2022 Zhao Zhen <jeremiazhao@tencent.com> - 3.24.34-1
- Initial building.
